#define com_maroontress_libcgi_mime_Parameter_IMPORT
#define std_lang_String_IMPORT

#include <string.h>
#include <stdlib.h>
#include <com/maroontress/libcgi/mime/Parameter.h>
#include <std/lang/String.h>

struct Parameter {
    struct String *name;
    struct String *value;
};

void
Parameter_free(struct Parameter *param)
{
    String_free(param->name);
    String_free(param->value);
    free(param);
}

struct Parameter *
Parameter_create(const char *name, const char *value)
{
    struct Parameter *p;
    
    if ((p = (struct Parameter *)malloc(sizeof(*p))) == NULL)
	return NULL;
    p->name = NULL;
    p->value = NULL;

    if ((p->name = String_intern(name)) == NULL
	|| (p->value = String_intern(value)) == NULL) {
	Parameter_free(p);
	return NULL;
    }
    return p;
}

struct String *
Parameter_getName(struct Parameter *param)
{
    return param->name;
}

struct String *
Parameter_getValue(struct Parameter *param)
{
    return param->value;
}
