#define com_maroontress_libcgi_Request_IMPORT
#define com_maroontress_libcgi_mime_ContentType_IMPORT
#define com_maroontress_libcgi_mime_Parameter_IMPORT
#define com_maroontress_libcgi_request_MultipartPostRequest_IMPORT
#define com_maroontress_libcgi_request_PostRequest_IMPORT
#define com_maroontress_libcgi_request_URLEncodedPostRequest_IMPORT
#define std_lang_String_IMPORT

#include <stdlib.h>
#include <unistd.h>
#include <com/maroontress/libcgi/Request.h>
#include <com/maroontress/libcgi/mime/ContentType.h>
#include <com/maroontress/libcgi/mime/Parameter.h>
#include <com/maroontress/libcgi/request/MultipartPostRequest.h>
#include <com/maroontress/libcgi/request/PostRequest.h>
#include <com/maroontress/libcgi/request/URLEncodedPostRequest.h>
#include <std/lang/String.h>

static struct Request *
createPostRequest(struct ContentType *ct)
{
    struct Parameter *p;
    struct String *boundary;

    if (ContentType_matches(ct, "application", "x-www-form-urlencoded"))
        return URLEncodedPostRequest_create();
    if (!ContentType_matches(ct, "multipart", "form-data")
	|| (p = ContentType_getParameter(ct, "boundary")) == NULL
	|| (boundary = Parameter_getValue(p)) == NULL) {
        return NULL;
    }
    return MultipartPostRequest_create(String_getData(boundary));
}

struct Request *
PostRequest_create(void)
{
    struct Request *r;
    const char *contentType;
    struct ContentType *ct;

    if ((contentType = getenv("CONTENT_TYPE")) == NULL)
        return NULL;
    if ((ct = ContentType_create(contentType)) == NULL)
        return NULL;
    r = createPostRequest(ct);
    ContentType_free(ct);
    return r;
}
